
% GNUProlog nezna not/1 ?

mynot(X) :- call(X), !, fail.
mynot(_).

% Definice tahu

valid(N,X,Y) :- X >= 0, Y >= 0, X < N, Y < N.
legalmove(N,X,Y,X1,Y1) :- move(X,Y,X1,Y1), valid(N,X1,Y1).

move(X,Y,X1,Y1) :- X1 is X+1, Y1 is Y+2.
move(X,Y,X1,Y1) :- X1 is X+1, Y1 is Y-2.
move(X,Y,X1,Y1) :- X1 is X-1, Y1 is Y+2.
move(X,Y,X1,Y1) :- X1 is X-1, Y1 is Y-2.
move(X,Y,X1,Y1) :- X1 is X+2, Y1 is Y+1.
move(X,Y,X1,Y1) :- X1 is X+2, Y1 is Y-1.
move(X,Y,X1,Y1) :- X1 is X-2, Y1 is Y+1.
move(X,Y,X1,Y1) :- X1 is X-2, Y1 is Y-1.

% Heuristika

free(N,X,Y,Visited) :-
  legalmove(N,X,Y,X1,Y1),
  mynot(member([X1,Y1],Visited)).
countfree(N,X,Y,Visited,Count) :-
  bagof([X,Y],free(N,X,Y,Visited),List),
  length(List,Count).
listfreemoves(N,X,Y,Visited,List) :-
  bagof([Count,X1,Y1],(legalmove(N,X,Y,X1,Y1),
  countfree(N,X1,Y1,Visited,Count)),List).
sortedlistfreemoves(N,X,Y,Visited,SortedList) :-
  listfreemoves(N,X,Y,Visited,List),
  sort(List,SortedList).
movefromsortedlist(N,X,Y,X1,Y1,Visited) :-
  sortedlistfreemoves(N,X,Y,Visited,SortedList),
  member([_,X1,Y1],SortedList).

next(_,_,_,0,Visited,Track) :- reverse(Visited, Track), !.
next(N,X,Y,Moves,Visited,Track) :-
  mynot(member([X,Y],Visited)),
  movefromsortedlist(N,X,Y,X1,Y1,Visited),
  Moves1 is Moves-1, next(N,X1,Y1,Moves1,[[X,Y]|Visited],Track).

% Jednoduche hledani

next_simple(_,_,_,0,Visited,Track) :- reverse(Visited, Track), !.
next_simple(N,X,Y,Moves,Visited,Track) :-
  mynot(member([X,Y],Visited)),
  legalmove(N,X,Y,X1,Y1),
  Moves1 is Moves-1, next_simple(N,X1,Y1,Moves1,[[X,Y]|Visited],Track).

% Vstupni body algoritmu

% Jednoduche hledani NxN, Track je vysledna cesta
knight_simple(N,Track) :- N2 is N * N, next_simple(N,0,0,N2,[],Track).

% Heuristika na NxN, Track je vysledna cesta
knight(N,Track) :- N2 is N * N, next(N,0,0,N2,[],Track).

% Count je pocet ruznych reseni na NxN
count(N,Count) :- setof(Track,knight_simple(N,Track),List), length(List,Count).
